DL_EncryptorBase< T > Class Template Referenceabstract

_ More...

`#include <pubkey.h>`

Inheritance diagram for DL_EncryptorBase< T >:

## Public Types

typedef T | Element

## Public Member Functions

void | Encrypt (RandomNumberGenerator &rng, const byte *plaintext, size_t plaintextLength, byte *ciphertext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| encrypt a byte string More...
size_t | MaxPlaintextLength (size_t ciphertextLength) const
size_t | CiphertextLength (size_t plaintextLength) const
bool | ParameterSupported (const char *name) const
virtual BufferedTransformation * | CreateEncryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new encryption filter More...
virtual size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0 More...
virtual size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual PublicKey & | AccessPublicKey ()=0
virtual const PublicKey & | GetPublicKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Protected Types

typedef DL_PublicKey< T > | KeyInterface

## Protected Member Functions

virtual const DL_KeyAgreementAlgorithm< Element > & | GetKeyAgreementAlgorithm () const =0
virtual const DL_KeyDerivationAlgorithm< Element > & | GetKeyDerivationAlgorithm () const =0
virtual const DL_SymmetricEncryptionAlgorithm & | GetSymmetricEncryptionAlgorithm () const =0
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
virtual KeyInterface & | AccessKeyInterface ()=0
virtual const KeyInterface & | GetKeyInterface () const =0

## Detailed Description

### template<class T>
class DL_EncryptorBase< T >

_

Definition at line 1215 of file pubkey.h.

## Member Function Documentation

template<class T>

void DL_EncryptorBase< T >::Encrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | plaintext,
|  | size_t | plaintextLength,
|  | byte * | ciphertext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

inline virtual

encrypt a byte string

Precondition
  CiphertextLength(plaintextLength) != 0 (i.e., plaintext isn't too long)
  size of ciphertext == CiphertextLength(plaintextLength)

Implements PK_Encryptor.

Definition at line 1220 of file pubkey.h.

virtual BufferedTransformation* PK_Encryptor::CreateEncryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

virtual inherited

create a new encryption filter

Note
  The caller is responsible for deleting the returned pointer.
  Encoding parameters should be passed in the "EP" channel.

virtual size_t PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const

inline virtual inherited

return fixed ciphertext length, if one exists, otherwise return 0

Note
  "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length.

Definition at line 1211 of file cryptlib.h.

Referenced by PK_Decryptor::FixedLengthDecrypt().

The documentation for this class was generated from the following file:

- pubkey.h